#include <avr/io.h>		// include I/O definitions (port names, pin names, etc)
#include <avr/interrupt.h>	// include interrupt support
#include <util/delay.h>
#include "Oregon.h"


uint8_t volatile message[21];
uint8_t volatile nibble;
uint16_t volatile period;
uint8_t volatile nibble_cntr = 0;
uint8_t volatile lastbit;
uint16_t volatile ICR1tmp = 0;
uint8_t volatile preamble;
uint8_t status;
extern uint8_t databuffer[32];
extern volatile char received ;

enum global_state
{
	IDLE = 0,
	PREAMBLE_DETECTED = 1,
	SYNC_AWAITING = 2,
	SYNC_RECEIVING = 3,
	DATA_RECEIVING = 4
};

uint8_t volatile bit_cntr;
uint8_t volatile bit_cntr2;
uint8_t volatile preamble_cntr;
uint8_t volatile manchester[3];
char volatile STATE_DECODER = IDLE;;



ISR(TIMER1_CAPT_vect )

{
PORTB &= 0b11111110;
period =   ICR1 - ICR1tmp;
ICR1tmp = ICR1;
	
	if(period > 800 && period < 1200)
	{	
		if (STATE_DECODER == IDLE ) preamble_cntr++;
		if (preamble_cntr>17 && STATE_DECODER == IDLE) {STATE_DECODER = SYNC_AWAITING; }

		if (STATE_DECODER == SYNC_RECEIVING || STATE_DECODER == DATA_RECEIVING)
		{
		bit_cntr+= 2;
		if(bit_cntr == 4)
			bit_received();
			if (bit_cntr2 == 4)
			nibble_received();
		}
	}
	else if(period > 330 && period < 600)
	{	
	if (STATE_DECODER == SYNC_AWAITING) STATE_DECODER = SYNC_RECEIVING;

	if (STATE_DECODER == SYNC_RECEIVING || STATE_DECODER == DATA_RECEIVING)
	{
	bit_cntr++;
		if(bit_cntr == 4)
		{
			return_to_idle();
		}
	}
	}

	else 
		return_to_idle();
	
}

ISR(INT1_vect )
{
	if bit_is_set(PIND, 3) lastbit = 1;
	else lastbit = 0;
	PORTB |= 0b00000001;

}

void return_to_idle()
{
	STATE_DECODER = IDLE;
	preamble_cntr = 0;
	bit_cntr = 0;
	bit_cntr2 = 0;
	nibble_cntr = 0;
	nibble = 0;
}

void bit_received()
{
		if(lastbit) 
		{
		}
		else 
		{
		nibble |= 0b10000000;
		}
		nibble = nibble>>1;
		bit_cntr = 0;
		bit_cntr2++;
}
	
void nibble_received()
{
	bit_cntr2 = 0;

	nibble = nibble>>3;
		if (STATE_DECODER == SYNC_RECEIVING)
		{
			if (nibble != 0x0A) return_to_idle();
			else 
			STATE_DECODER = DATA_RECEIVING;
			
		}


		if (STATE_DECODER == DATA_RECEIVING)
		{
		message[nibble_cntr] = nibble;
		nibble_cntr++;
		if (nibble_cntr == 20) {send_temp();return_to_idle();}
		}
		
}

void send_temp()
{
		databuffer[1] = message[11];
		databuffer[2] = message[10];
		databuffer[3] = message[9];
				databuffer[4] = message[12];
				databuffer[5] = message[14];
				databuffer[6] = message[13];
		received = 1;
}
